#!/usr/bin/ruby1.8 
MEDIA_BASE_DIR='/tmp'
require 'open3'
require 'fileutils'
puts "click on the window to record"
info=`xwininfo | grep -e "Height" -e"Width" -e "Absolute upper-left X:" -e "Absolute upper-left Y:"`
pos=info.split("\n").inject({}){|h,i| a=i.split(":"); h.merge({a[0].strip.split(" ").last => a[1].strip})}

pos['Width']=pos['Width'].to_i
pos['Height']=pos['Height'].to_i
pos['Width']+=1 if pos['Width'].odd?
pos['Height']+=1 if pos['Height'].odd?
rec_name=""
base_name=nil
existing=nil
while rec_name=="" or existing do
  puts "directory where to store recordings?"
  rec_name=STDIN.gets.chomp
  base_name=File.join(MEDIA_BASE_DIR, rec_name)
  existing=File.exists?(base_name)
  if existing
    puts "File or directory exists, enter other name" 
  end
end 

r=FileUtils.mkdir( base_name )

def start_recording(base_name, pos)
	dest=File.join(base_name,Time.now.strftime('%Y%m%d-%H%M%S'))
	ffmpeg_command="ffmpeg -f oss -i /dev/dsp -f x11grab -r 25 -s #{pos['Width']}x#{pos['Height']} -i :0.0+#{pos['X']},#{pos['Y']} -qscale 15 -vcodec  libxvid -aspect 4:3 #{dest}.avi"
puts ffmpeg_command
	return Thread.new do 
	   Thread.current[:stdin], Thread.current[:stdout], Thread.current[:stderr ]=Open3.popen3(ffmpeg_command)
	end
end


puts "Recording..."
th= start_recording(base_name, pos)

c=""
until c=="q"
  c=STDIN.getc.chr
  case c 
  when "q":
    th[:stdin].write("q")
    puts "Recording session stopped, see results in #{base_name}"
  when "p":
    th[:stdin].write("q")
    puts "Recording stopped! Enter n to record new video of same region."
  when "n":
    puts "Recording..."
    th = start_recording(base_name, pos)
  end
end
